﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CascadeDropDown.Models;

namespace CascadeDropDown.Controllers
{
    public class ReportController : Controller
    {
        public ActionResult Report()
        {
            return View();
        }


        public JsonResult GetQueryParameter(string text)
        {
            List<QueryFields> FinalResList = new List<QueryFields>();

            QueryFields qf0 = new QueryFields()
            {
                QueryParameterText = "Airport",
                QueryParameterValue = "Airport"
            };
            FinalResList.Add(qf0);

            QueryFields qf1 = new QueryFields()
            {
                QueryParameterText = "Building Name",
                QueryParameterValue = "Building_Name"
            };
            FinalResList.Add(qf1);          
           
            FinalResList = FinalResList.OrderBy(x => x.QueryParameterText).ToList<QueryFields>();


            if (!string.IsNullOrEmpty(text))
            {
                return Json(FinalResList.Where(p => p.QueryParameterText.ToLower().Contains(text.ToLower())).ToList<QueryFields>(), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(FinalResList, JsonRequestBehavior.AllowGet);
            }
        }

        public JsonResult GetQueryValues(string QueryFieldValue, string text = "")
        {
            List<QueryValue> valueList = new List<QueryValue>();
            switch (QueryFieldValue)
            {             

                case "Airport":
                    List<QueryValue> airport = new List<QueryValue>();
                    QueryValue qv1 = new QueryValue()
                    {
                         QueryValueText = "Sky Harbor Airport",
                         QueryValueValue = "PHX"
                    };
                    airport.Add(qv1);

                    QueryValue qv2 = new QueryValue()
                    {
                         QueryValueText = "Good Year Airport",
                         QueryValueValue = "GYR"
                    };
                    airport.Add(qv2);

                     QueryValue qv3 = new QueryValue()
                    {
                         QueryValueText = "Deer Valley Airport",
                         QueryValueValue = "DVT"
                    };
                    airport.Add(qv3);

                    QueryValue qv4 = new QueryValue()
                    {
                         QueryValueText = "ABC Airport",
                         QueryValueValue = "ABC"
                    };
                    airport.Add(qv4);

                    QueryValue qv5 = new QueryValue()
                    {
                         QueryValueText = "DEF Airport",
                         QueryValueValue = "DEF"
                    };
                    airport.Add(qv5);

                     QueryValue qv6 = new QueryValue()
                    {
                         QueryValueText = "GHI Airport",
                         QueryValueValue = "GHI"
                    };
                     airport.Add(qv6);

                    valueList = airport;
                    break;
                case "Building_Name":
                    List<QueryValue> buildings = new List<QueryValue>();
                    QueryValue b1 = new QueryValue()
                    {
                         QueryValueText = "Terminal 2",
                         QueryValueValue = "T2"
                    };
                    buildings.Add(b1);

                    QueryValue b2 = new QueryValue()
                    {
                         QueryValueText = "Terminal 3",
                         QueryValueValue = "T3"
                    };
                    buildings.Add(b2);

                     QueryValue b3 = new QueryValue()
                    {
                         QueryValueText = "Terminal 4",
                         QueryValueValue = "T4"
                    };
                     buildings.Add(b3);
                     QueryValue b4 = new QueryValue()
                    {
                         QueryValueText = "Terminal 5",
                         QueryValueValue = "T5"
                    };
                    buildings.Add(b4);

                    QueryValue b5 = new QueryValue()
                    {
                         QueryValueText = "Terminal 6",
                         QueryValueValue = "T6"
                    };
                    buildings.Add(b5);

                     QueryValue b6 = new QueryValue()
                    {
                         QueryValueText = "Terminal 7",
                         QueryValueValue = "T7"
                    };
                     buildings.Add(b6);

                     valueList = buildings;
                    break;               
            }
            if (!string.IsNullOrEmpty(text))
            {
                return Json(valueList.Where(p => p.QueryValueText.ToLower().Contains(text.ToLower())).ToList<QueryValue>(), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(valueList, JsonRequestBehavior.AllowGet);
            }
        }
    }
}
